package com.huiju.welcome.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.huiju.welcome.common.base.ResponseBean;
import com.huiju.welcome.mapper.*;
import com.huiju.welcome.model.*;
import com.huiju.welcome.service.ISysUserService;
import com.huiju.welcome.utils.StatusUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author jobob
 * @since 2019-03-12
 */
@Service
public class SysUserServiceImpl extends ServiceImpl<SysUserMapper, SysUser> implements ISysUserService {

    @Autowired
    private SysUserMapper sysUserMapper;

    @Autowired
    private SysMenuMapper sysMenuMapper;

    @Autowired
    private SysRoleMenuMapper sysRoleMenuMapper;

    @Autowired
    private SysUserRoleMapper sysUserRoleMapper;

    @Autowired
    private SysRoleMapper sysRoleMapper;

    @Override
    public SysUser getDetailByLoginname(String username) {
        QueryWrapper<SysUser> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("loginname",username);
        return sysUserMapper.selectOne(queryWrapper);
    }

    @Override
    public SysUser getByPhone(String phone) {
        QueryWrapper<SysUser> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("phone",phone);
        queryWrapper.eq("status", StatusUtils.Normal);
        queryWrapper.last("limit 1");
        return sysUserMapper.selectOne(queryWrapper);
    }

    @Override
    public ResponseBean userRoleTree() {
        return null;
    }

    @Override
    public ResponseBean userManagementList(IPage<SysUserRole> pg,String userName, String phone) {
        ResponseBean responseBean= new ResponseBean();
        IPage<SysUserRole> list= sysUserRoleMapper.userManagementList(pg,userName,phone);
        responseBean.addSuccess(list);
        return responseBean;
    }

    @Override
    public ResponseBean roleManagementList(IPage<SysRole> pg, String roleName) {
        ResponseBean responseBean= new ResponseBean();
        IPage<SysRole> list= sysRoleMapper.roleManagementList(pg,roleName);
        responseBean.addSuccess(list);
        return responseBean;
    }

    @Override
    public Map<String, Object> getProfileWithRights(Integer userId) {
        SysUser user = sysUserMapper.getUserWithAuthority(userId);
        if (null == user) return null;
        user.setPassword(null);

        List<SysMenu> menus = sysMenuMapper.getAllMenusWithAuthority();

        return new HashMap<String, Object>(){{
            put("user", user);
            put("menus", menus);
        }};
    }
}
